gtkmm: Gtk::ListBox Class Reference

gtkmm 4.12.0

Public Types | Public Member Functions | Static Public Member Functions | Related Symbols | List of all members
Gtk::ListBox Class Reference
Widgets | Container Widgets

A ListBox is a vertical container that contains ListBoxRow children. More...

`#include <gtkmm/listbox.h>`

Inheritance diagram for Gtk::ListBox:
[legend]

## Public Types
typedef sigc::slot< bool(ListBoxRow *)> | SlotFilter
| For instance: bool on_filter(ListBoxRow* row);.
typedef sigc::slot< int(ListBoxRow *, ListBoxRow *)> | SlotSort
| For instance: int on_sort(ListBoxRow* row1, ListBoxRow* row2);.
typedef sigc::slot< void(ListBoxRow *, ListBoxRow *)> | SlotUpdateHeader
| For instance: void on_update_header(ListBoxRow* row, ListBoxRow* before);.
typedef sigc::slot< void(ListBoxRow *)> | SlotForeach
| For instance, void on_foreach(ListBoxRow* row);.
template<typename T_item >
using | SlotCreateWidget = sigc::slot< Gtk::Widget *(const Glib::RefPtr< T_item > &)>
| For instance: Gtk::Widget* on_create_widget(const Glib::RefPtr<T_item>& item);.
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock > &)>
| Callback type for adding a function to update animations.
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from Gtk::Accessible
enum class | Role { ALERT , ALERT_DIALOG , BANNER , BUTTON , CAPTION , CELL , CHECKBOX , COLUMN_HEADER , COMBO_BOX , COMMAND , COMPOSITE , DIALOG , DOCUMENT , FEED , FORM , GENERIC , GRID , GRID_CELL , GROUP , HEADING , IMG , INPUT , LABEL , LANDMARK , LEGEND , LINK , LIST , LIST_BOX , LIST_ITEM , LOG , MAIN , MARQUEE , MATH , METER , MENU , MENU_BAR , MENU_ITEM , MENU_ITEM_CHECKBOX , MENU_ITEM_RADIO , NAVIGATION , NONE , NOTE , OPTION , PRESENTATION , PROGRESS_BAR , RADIO , RADIO_GROUP , RANGE , REGION , ROW , ROW_GROUP , ROW_HEADER , SCROLLBAR , SEARCH , SEARCH_BOX , SECTION , SECTION_HEAD , SELECT , SEPARATOR , SLIDER , SPIN_BUTTON , STATUS , STRUCTURE , SWITCH , TAB , TABLE , TAB_LIST , TAB_PANEL , TEXT_BOX , TIME , TIMER , TOOLBAR , TOOLTIP , TREE , TREE_GRID , TREE_ITEM , WIDGET , WINDOW , TOGGLE_BUTTON , APPLICATION }
enum class | State { BUSY , CHECKED , DISABLED , EXPANDED , HIDDEN , INVALID , PRESSED , SELECTED , VISITED }
enum class | Property { AUTOCOMPLETE , DESCRIPTION , HAS_POPUP , KEY_SHORTCUTS , LABEL , LEVEL , MODAL , MULTI_LINE , MULTI_SELECTABLE , ORIENTATION , PLACEHOLDER , READ_ONLY , REQUIRED , ROLE_DESCRIPTION , SORT , VALUE_MAX , VALUE_MIN , VALUE_NOW , VALUE_TEXT }
enum class | Relation { ACTIVE_DESCENDANT , COL_COUNT , COL_INDEX , COL_INDEX_TEXT , COL_SPAN , CONTROLS , DESCRIBED_BY , DETAILS , ERROR_MESSAGE , FLOW_TO , LABELLED_BY , OWNS , POS_IN_SET , ROW_COUNT , ROW_INDEX , ROW_INDEX_TEXT , ROW_SPAN , SET_SIZE }
enum class | PlatformState { FOCUSABLE , FOCUSED , ACTIVE }

## Public Member Functions
| ListBox (ListBox && src) noexcept
ListBox & | operator= (ListBox && src) noexcept
| ListBox (const ListBox &)=delete
ListBox & | operator= (const ListBox &)=delete
| ~ListBox () noexcept override
GtkListBox * | gobj ()
| Provides access to the underlying C GObject.
const GtkListBox * | gobj () const
| Provides access to the underlying C GObject.
| ListBox ()
void | prepend (Widget & child)
| Prepend a widget to the list.
void | append (Widget & child)
| Append a widget to the list.
void | insert (Widget & child, int position)
| Insert the child into the box at position.
void | remove (Widget & child)
| Removes a child from box.
void | remove_all ()
| Removes all rows from box.
ListBoxRow * | get_selected_row ()
| Gets the selected row, or `nullptr` if no rows are selected.
const ListBoxRow * | get_selected_row () const
| Gets the selected row, or `nullptr` if no rows are selected.
ListBoxRow * | get_row_at_index (int index)
| Gets the n-th child in the list (not counting headers).
const ListBoxRow * | get_row_at_index (int index) const
| Gets the n-th child in the list (not counting headers).
ListBoxRow * | get_row_at_y (int y)
| Gets the row at the y position.
const ListBoxRow * | get_row_at_y (int y) const
| Gets the row at the y position.
void | select_row (ListBoxRow & row)
| Make row the currently selected row.
void | unselect_row ()
| Unselects the currently selected row, if any.
void | set_placeholder (Widget & placeholder)
| Sets the placeholder widget that is shown in the list when it doesn't display any visible children.
void | unset_placeholder ()
| Removes the placeholder widget, if any.
void | set_adjustment (const Glib::RefPtr< Adjustment > & adjustment)
| Sets the adjustment (if any) that the widget uses to for vertical scrolling.
Glib::RefPtr< Adjustment > | get_adjustment ()
| Gets the adjustment (if any) that the widget uses to for vertical scrolling.
Glib::RefPtr< const Adjustment > | get_adjustment () const
| Gets the adjustment (if any) that the widget uses to for vertical scrolling.
void | selected_foreach (const SlotForeach & slot)
std::vector< ListBoxRow * > | get_selected_rows ()
| Creates a list of all selected children.
std::vector< ListBoxRow * > | get_selected_rows () const
| Creates a list of all selected children.
void | unselect_row (ListBoxRow * row)
| Unselects a single row of box, if the selection mode allows it.
void | select_all ()
| Select all children of box, if the selection mode allows it.
void | unselect_all ()
| Unselect all children of box, if the selection mode allows it.
void | set_selection_mode (SelectionMode mode)
| Sets how selection works in the listbox.
SelectionMode | get_selection_mode () const
| Gets the selection mode of the listbox.
void | set_filter_func (const SlotFilter & slot)
| Sets a filter function.
void | unset_filter_func ()
| Removes the filter function, if any.
void | set_sort_func (const SlotSort & slot)
| Sets a sort function.
void | unset_sort_func ()
| Removes the sort function, if any.
void | set_header_func (const SlotUpdateHeader & slot)
| Sets a header function.
void | unset_header_func ()
| Removes the header function, if any.
void | invalidate_filter ()
| Update the filtering for all rows.
void | invalidate_sort ()
| Update the sorting for all rows.
void | invalidate_headers ()
| Update the separators for all rows.
void | set_activate_on_single_click (bool single=true)
| If single is `true`, rows will be activated when you click on them, otherwise you need to double-click.
bool | get_activate_on_single_click () const
| Returns whether rows activate on single clicks.
void | drag_unhighlight_row ()
| If a row has previously been highlighted via drag_highlight_row(), it will have the highlight removed.
void | drag_highlight_row (ListBoxRow & row)
| Add a drag highlight to a row.
void | bind_model (const Glib::RefPtr< Gio::ListModel > & model, const SlotCreateWidget< Glib::Object > & slot_create_widget)
| Binds a Gio::ListModel.
template<typename T_item , typename T_slot >
void | bind_list_store (const Glib::RefPtr< Gio::ListStore< T_item > > & store, T_slot && slot_create_widget)
| Binds a Gio::ListStore<>.
void | set_show_separators (bool show_separators=true)
| Sets whether the list box should show separators between rows.
bool | get_show_separators () const
| Returns whether the list box should show separators between rows.
Glib::PropertyProxy< SelectionMode > | property_selection_mode ()
| The selection mode used by the list box.
Glib::PropertyProxy_ReadOnly< SelectionMode > | property_selection_mode () const
| The selection mode used by the list box.
Glib::PropertyProxy< bool > | property_activate_on_single_click ()
| Determines whether children can be activated with a single click, or require a double-click.
Glib::PropertyProxy_ReadOnly< bool > | property_activate_on_single_click () const
| Determines whether children can be activated with a single click, or require a double-click.
Glib::PropertyProxy< bool > | property_accept_unpaired_release ()
| Whether to accept unpaired release events.
Glib::PropertyProxy_ReadOnly< bool > | property_accept_unpaired_release () const
| Whether to accept unpaired release events.
Glib::PropertyProxy< bool > | property_show_separators ()
| Whether to show separators between rows.
Glib::PropertyProxy_ReadOnly< bool > | property_show_separators () const
| Whether to show separators between rows.
Glib::SignalProxy< void(ListBoxRow *)> | signal_row_selected ()
Glib::SignalProxy< void(ListBoxRow *)> | signal_row_activated ()
Glib::SignalProxy< void()> | signal_selected_rows_changed ()
Public Member Functions inherited from Gtk::Widget
| Widget (Widget && src) noexcept
Widget & | operator= (Widget && src) noexcept
| Widget (const Widget &)=delete
Widget & | operator= (const Widget &)=delete
| ~Widget () noexcept override
| Destroys the widget.
GtkWidget * | gobj ()
| Provides access to the underlying C GObject.
const GtkWidget * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ConstraintTarget > | make_refptr_constrainttarget ()
| Converts this widget to a reference counted Gtk::ConstraintTarget.
Glib::RefPtr< const ConstraintTarget > | make_refptr_constrainttarget () const
| Converts this widget to a reference counted Gtk::ConstraintTarget.
void | show ()
| Flags a widget to be displayed.
void | hide ()
| Reverses the effects of show().
void | queue_draw ()
| Schedules this widget to be redrawn in the paint phase of the current or the next frame.
void | queue_resize ()
| Flags a widget to have its size renegotiated.
void | queue_allocate ()
| Flags the widget for a rerun of the size_allocate_vfunc() function.
void | size_allocate (const Allocation & allocation, int baseline)
| Allocates widget with a transformation that translates the origin to the position in allocation.
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout.
void | measure (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
| Measures widget in the orientation orientation and for the given for_size.
void | get_preferred_size (Requisition & minimum_size, Requisition & natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management.
void | set_layout_manager (const Glib::RefPtr< LayoutManager > & layout_manager)
| Sets the layout manager delegate instance that provides an implementation for measuring and allocating the children of widget.
void | unset_layout_manager ()
| Undoes the effect of a previous call to set_layout_manager().
Glib::RefPtr< LayoutManager > | get_layout_manager ()
| Retrieves the layout manager used by widget.
Glib::RefPtr< const LayoutManager > | get_layout_manager () const
| Retrieves the layout manager used by widget.
bool | mnemonic_activate (bool group_cycling)
| Emits the signal_mnemonic_activate() signal.
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them.
void | set_can_focus (bool can_focus=true)
| Specifies whether the input focus can enter the widget or any of its children.
bool | get_can_focus () const
| Determines whether the input focus can enter widget or any of its children.
void | set_focusable (bool focusable=true)
| Specifies whether widget can own the input focus.
bool | get_focusable () const
| Determines whether widget can own the input focus.
bool | has_focus () const
| Determines if the widget has the global input focus.
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel.
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus.
bool | grab_focus ()
| Causes widget to have the keyboard focus for the `Gtk::Window` it's inside.
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse.
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse.
void | set_can_target (bool can_target=true)
| Sets whether widget can be the target of pointer events.
bool | get_can_target () const
| Queries whether widget can be the target of pointer events.
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel.
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default.
void | set_name (const Glib::ustring & name)
| Sets a widgets name.
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget.
void | set_state_flags (StateFlags flags, bool clear=true)
| Turns on flag values in the current widget state.
void | unset_state_flags (StateFlags flags)
| Turns off flag values for the current widget state.
StateFlags | get_state_flags () const
| Returns the widget state as a flag set.
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget.
bool | get_sensitive () const
| Returns the widget’s sensitivity.
bool | is_sensitive () const
| Returns the widget’s effective sensitivity.
void | set_visible (bool visible=true)
| Sets the visibility state of widget.
bool | get_visible () const
| Determines whether the widget is visible.
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible.
bool | is_drawable () const
| Determines whether widget can be drawn to.
bool | get_realized () const
| Determines whether widget is realized.
bool | get_mapped () const
| Whether the widget is mapped.
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its parent.
bool | get_child_visible () const
| Gets the value set with set_child_visible().
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget.
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget.
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget.
Allocation | get_allocation () const
| Retrieves the widget’s location.
std::optional< Gdk::Graphene::Rect > | compute_bounds (const Widget & target) const
| Computes the bounds for the widget in the coordinate space of target.
std::optional< Gdk::Graphene::Point > | compute_point (const Widget & target, const Gdk::Graphene::Point & point) const
| Translates the given point in the widget's coordinates to coordinates relative to target’s coordinate system.
int | get_width () const
| Returns the content width of the widget.
int | get_height () const
| Returns the content height of the widget.
int | get_baseline () const
| Returns the baseline that has currently been allocated to widget.
int | get_size (Orientation orientation) const
| Returns the content width or height of the widget.
Widget * | get_parent ()
| Returns the parent widget of widget.
const Widget * | get_parent () const
| Returns the parent widget of widget.
Root * | get_root ()
| Returns the `Gtk::Root` widget of widget.
const Root * | get_root () const
| Returns the `Gtk::Root` widget of widget.
Native * | get_native ()
| Returns the nearest `Gtk::Native` ancestor of widget.
const Native * | get_native () const
| Returns the nearest `Gtk::Native` ancestor of widget.
bool | child_focus (DirectionType direction)
| Called by widgets as the user moves around the window using keyboard shortcuts.
bool | keynav_failed (DirectionType direction)
| Emits the `::keynav-failed` signal on the widget.
void | error_bell ()
| Notifies the user about an input-related error on this widget.
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget.
void | get_size_request (int & width, int & height) const
| Gets the size request that was explicitly set for the widget using set_size_request().
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent.
double | get_opacity () const
| #Fetches the requested opacity for this widget.
void | set_overflow (Overflow overflow)
| Sets how widget treats content that is drawn outside the widget's content area.
Overflow | get_overflow () const
| Returns the widget’s overflow value.
Widget * | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type.
const Widget * | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type.
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels.
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the `Gdk::Display` for the toplevel window associated with this widget.
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget.
Glib::RefPtr< Gdk::Clipboard > | get_clipboard ()
| Gets the clipboard object for widget.
Glib::RefPtr< const Gdk::Clipboard > | get_clipboard () const
| Gets the clipboard object for widget.
Glib::RefPtr< Gdk::Clipboard > | get_primary_clipboard ()
| Gets the primary clipboard of widget.
Glib::RefPtr< const Gdk::Clipboard > | get_primary_clipboard () const
| Gets the primary clipboard of widget.
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space.
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space.
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget.
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag will be used.
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space.
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space.
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget.
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag will be used.
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible.
void | set_expand (bool expand=true)
| Sets whether the widget would like any available extra space in both directions.
Align | get_halign () const
| Gets the horizontal alignment of widget.
void | set_halign (Align align)
| Sets the horizontal alignment of widget.
Align | get_valign () const
| Gets the vertical alignment of widget.
void | set_valign (Align align)
| Sets the vertical alignment of widget.
int | get_margin_start () const
| Gets the start margin of widget.
void | set_margin_start (int margin)
| Sets the start margin of widget.
int | get_margin_end () const
| Gets the end margin of widget.
void | set_margin_end (int margin)
| Sets the end margin of widget.
int | get_margin_top () const
| Gets the top margin of widget.
void | set_margin_top (int margin)
| Sets the top margin of widget.
int | get_margin_bottom () const
| Gets the bottom margin of widget.
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget.
void | set_margin (int margin)
| Set all 4 margins to the same value.
bool | is_ancestor (Widget & ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers.
bool | translate_coordinates (Widget & dest_widget, double src_x, double src_y, double & dest_x, double & dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations.
bool | contains (double x, double y) const
| Tests if the point at ( x, y) is contained in widget.
Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT)
| Finds the descendant of widget closest to the point ( x, y).
const Widget * | pick (double x, double y, PickFlags flags=PickFlags::DEFAULT) const
| Finds the descendant of widget closest to the point ( x, y).
void | add_controller (const Glib::RefPtr< EventController > & controller)
| Adds controller to widget so that it will receive events.
void | remove_controller (const Glib::RefPtr< EventController > & controller)
| Removes controller from widget, so that it doesn't process events anymore.
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new `Pango::Context` with the appropriate font map, font options, font description, and base direction for drawing text for this widget.
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a `Pango::Context` with the appropriate font map, font description, and base direction for this widget.
void | set_font_options (const Cairo::FontOptions & options)
| Sets the `cairo_font_options_t` used for Pango rendering in this widget.
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options().
Cairo::FontOptions | get_font_options () const
| Returns the `cairo_font_options_t` of widget.
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring & text)
| Creates a new `Pango::Layout` with the appropriate font map, font description, and base direction for drawing text for this widget.
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget.
TextDirection | get_direction () const
| Gets the reading direction for a particular widget.
void | set_cursor (const Glib::RefPtr< Gdk::Cursor > & cursor)
| Sets the cursor to be shown when pointer devices point towards widget.
void | set_cursor (const Glib::ustring & name={})
| Sets a named cursor to be shown when pointer devices point towards the widget.
Glib::RefPtr< Gdk::Cursor > | get_cursor ()
| Queries the cursor set on widget.
Glib::RefPtr< const Gdk::Cursor > | get_cursor () const
| Queries the cursor set on widget.
std::vector< Widget * > | list_mnemonic_labels ()
| Returns the widgets for which this widget is the target of a mnemonic.
std::vector< const Widget * > | list_mnemonic_labels () const
| Returns the widgets for which this widget is the target of a mnemonic.
void | add_mnemonic_label (Widget & label)
| Adds a widget to the list of mnemonic labels for this widget.
void | remove_mnemonic_label (Widget & label)
| Removes a widget from the list of mnemonic labels for this widget.
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
| Checks to see if a drag movement has passed the GTK drag threshold.
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget.
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget.
void | set_parent (Widget & parent)
| Sets parent as the parent widget of widget.
void | unparent ()
| Dissociate widget from its parent.
void | map ()
| Causes a widget to be mapped if it isn’t already.
void | unmap ()
| Causes a widget to be unmapped if it’s currently mapped.
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located.
void | set_tooltip_text (const Glib::ustring & text)
| Sets text as the contents of the tooltip.
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget.
void | set_tooltip_markup (const Glib::ustring & markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language.
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget.
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the `has-tooltip` property on widget to has_tooltip.
bool | get_has_tooltip () const
| Returns the current value of the `has-tooltip` property.
bool | in_destruction () const
| Returns whether the widget is currently being destroyed.
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget.
Glib::RefPtr< const StyleContext > | get_style_context () const
| Returns the style context associated to widget.
guint | add_tick_callback (const SlotTick & slot)
| Queues an animation frame update and adds a callback to be called before each frame.
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback().
void | insert_action_group (const Glib::ustring & name, const Glib::RefPtr< Gio::ActionGroup > & group)
| Inserts group into widget.
void | remove_action_group (const Glib::ustring & name)
| Removes a group from the widget.
bool | activate_action (const Glib::ustring & name, const Glib::VariantBase & args={})
| Looks up the action in the action groups associated with the widget and its ancestors, and activates it.
void | activate_default ()
| Activates the `default.activate` action from widget.
void | set_font_map (const Glib::RefPtr< Pango::FontMap > & font_map)
| Sets the font map to use for Pango rendering.
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map of widget.
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map of widget.
Widget * | get_first_child ()
| Returns the widget’s first child.
const Widget * | get_first_child () const
| Returns the widget’s first child.
Widget * | get_last_child ()
| Returns the widget’s last child.
const Widget * | get_last_child () const
| Returns the widget’s last child.
Widget * | get_next_sibling ()
| Returns the widget’s next sibling.
const Widget * | get_next_sibling () const
| Returns the widget’s next sibling.
Widget * | get_prev_sibling ()
| Returns the widget’s previous sibling.
const Widget * | get_prev_sibling () const
| Returns the widget’s previous sibling.
Glib::RefPtr< Gio::ListModel > | observe_children ()
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< const Gio::ListModel > | observe_children () const
| Returns a `Gio::ListModel` to track the children of widget.
Glib::RefPtr< Gio::ListModel > | observe_controllers ()
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
Glib::RefPtr< const Gio::ListModel > | observe_controllers () const
| Returns a `Gio::ListModel` to track the Gtk::EventControllers of widget.
void | insert_after (Widget & parent, const Widget & previous_sibling)
| Inserts the Widget into the child widget list of parent after previous_sibling.
void | insert_before (Widget & parent, const Widget & next_sibling)
| Inserts the Widget into the child widget list of parent before next_sibling.
void | insert_at_start (Widget & parent)
| Inserts the Widget at the beginning of the child widget list of parent.
void | insert_at_end (Widget & parent)
| Inserts the Widget at the end of the child widget list of parent.
void | snapshot_child (Widget & child, const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Snapshot the a child of widget.
bool | should_layout () const
| Returns whether widget should contribute to the measuring and allocation of its parent.
Glib::ustring | get_css_name () const
| Returns the CSS name that is used for self.
void | add_css_class (const Glib::ustring & css_class)
| Adds a style class to widget.
void | remove_css_class (const Glib::ustring & css_class)
| Removes a style from widget.
bool | has_css_class (const Glib::ustring & css_class) const
| Returns whether css_class is currently applied to widget.
std::vector< Glib::ustring > | get_css_classes () const
| Returns the list of style classes applied to widget.
void | set_css_classes (const std::vector< Glib::ustring > & classes)
| Clear all style classes applied to widget and replace them with classes.
Gdk::RGBA | get_color () const
| Gets the current foreground color for the widget's CSS style.
Glib::SignalProxy< void()> | signal_show ()
Glib::SignalProxy< void()> | signal_hide ()
Glib::SignalProxy< void()> | signal_map ()
| Emitted on mapping of a widget to the screen.
Glib::SignalProxy< void()> | signal_unmap ()
Glib::SignalProxy< void()> | signal_realize ()
| Emitted on realization of a widget.
Glib::SignalProxy< void()> | signal_unrealize ()
Glib::SignalProxy< void(Gtk::StateFlags)> | signal_state_flags_changed ()
Glib::SignalProxy< void(TextDirection)> | signal_direction_changed ()
Glib::SignalProxy< bool(bool)> | signal_mnemonic_activate ()
Glib::SignalProxy< void()> | signal_destroy ()
| Emitted during the dispose phase.
Glib::SignalProxy< bool(int, int, bool, const Glib::RefPtr< Tooltip > &)> | signal_query_tooltip ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget.
Glib::PropertyProxy_ReadOnly< Widget * > | property_parent () const
| The parent widget of this widget.
Glib::PropertyProxy_ReadOnly< Root * > | property_root () const
| The `Gtk::Root` widget of the widget tree containing this widget.
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget.
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget.
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget.
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible.
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible.
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input.
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input.
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget or any of its descendents can accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus.
Glib::PropertyProxy< bool > | property_can_target ()
| Whether the widget can receive pointer events.
Glib::PropertyProxy_ReadOnly< bool > | property_can_target () const
| Whether the widget can receive pointer events.
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse.
Glib::PropertyProxy< bool > | property_focusable ()
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_focusable () const
| Whether this widget itself will accept the input focus.
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget.
Glib::PropertyProxy< bool > | property_receives_default ()
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| Whether the widget will receive the default action when it is focused.
Glib::PropertyProxy< Glib::RefPtr< Gdk::Cursor > > | property_cursor ()
| The cursor used by widget.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Cursor > > | property_cursor () const
| The cursor used by widget.
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of the signal_query_tooltip() signal on widget.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with Pango markup.
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string.
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space.
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space.
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally.
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally.
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget.
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget.
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget.
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally.
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the `hexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the `hexpand` property.
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically.
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the `vexpand` property.
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the `vexpand` property.
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget.
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget.
Glib::PropertyProxy< Overflow > | property_overflow ()
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< Overflow > | property_overflow () const
| How content outside the widget's content area is treated.
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_css_name () const
| The name of this widget in the CSS tree.
Glib::PropertyProxy< std::vector< Glib::ustring > > | property_css_classes ()
| A list of css classes applied to this widget.
Glib::PropertyProxy_ReadOnly< std::vector< Glib::ustring > > | property_css_classes () const
| A list of css classes applied to this widget.
Glib::PropertyProxy< Glib::RefPtr< LayoutManager > > | property_layout_manager ()
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< LayoutManager > > | property_layout_manager () const
| The `Gtk::LayoutManager` instance to use to compute the preferred size of the widget, and allocate its children.
Public Member Functions inherited from Gtk::Object
| Object (Object && src) noexcept
Object & | operator= (Object && src) noexcept
| ~Object () noexcept override
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from Gtk::Accessible
| Accessible (Accessible && src) noexcept
Accessible & | operator= (Accessible && src) noexcept
| ~Accessible () noexcept override
GtkAccessible * | gobj ()
| Provides access to the underlying C GObject.
const GtkAccessible * | gobj () const
| Provides access to the underlying C GObject.
Glib::RefPtr< ATContext > | get_at_context ()
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
Glib::RefPtr< const ATContext > | get_at_context () const
| Retrieves the accessible implementation for the given `Gtk::Accessible`.
bool | get_platform_state (PlatformState state) const
| Query a platform state, such as focus.
Glib::RefPtr< Accessible > | get_accessible_parent ()
| Retrieves the accessible parent for an accessible object.
Glib::RefPtr< const Accessible > | get_accessible_parent () const
| Retrieves the accessible parent for an accessible object.
void | set_accessible_parent (const Glib::RefPtr< Accessible > & parent, const Glib::RefPtr< Accessible > & next_sibling)
| Sets the parent and sibling of an accessible object.
Glib::RefPtr< Accessible > | get_first_accessible_child ()
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< const Accessible > | get_first_accessible_child () const
| Retrieves the first accessible child of an accessible object.
Glib::RefPtr< Accessible > | get_next_accessible_sibling ()
| Retrieves the next accessible sibling of an accessible object.
Glib::RefPtr< const Accessible > | get_next_accessible_sibling () const
| Retrieves the next accessible sibling of an accessible object.
void | update_next_accessible_sibling (const Glib::RefPtr< Accessible > & new_sibling)
| Updates the next accessible sibling of self.
bool | get_bounds (int & x, int & y, int & width, int & height) const
| Queries the coordinates and dimensions of this accessible.
Role | get_accessible_role () const
| Retrieves the accessible role of an accessible object.
void | update_state (State state, const Glib::ValueBase & value)
| Updates an accessible state.
void | update_property (Property property, const Glib::ValueBase & value)
| Updates an accessible property.
void | update_relation (Relation relation, const Glib::ValueBase & value)
| Updates an accessible relation.
void | reset_state (State state)
| Resets the accessible state to its default value.
void | reset_property (Property property)
| Resets the accessible property to its default value.
void | reset_relation (Relation relation)
| Resets the accessible relation to its default value.
Glib::PropertyProxy< Role > | property_accessible_role ()
| The accessible role of the given `Gtk::Accessible` implementation.
Glib::PropertyProxy_ReadOnly< Role > | property_accessible_role () const
| The accessible role of the given `Gtk::Accessible` implementation.
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable && src) noexcept
Buildable & | operator= (Buildable && src) noexcept
| ~Buildable () noexcept override
GtkBuildable * | gobj ()
| Provides access to the underlying C GObject.
const GtkBuildable * | gobj () const
| Provides access to the underlying C GObject.
Glib::ustring | get_buildable_id () const
| Gets the ID of the buildable object.
Public Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget (ConstraintTarget && src) noexcept
ConstraintTarget & | operator= (ConstraintTarget && src) noexcept
| ~ConstraintTarget () noexcept override
GtkConstraintTarget * | gobj ()
| Provides access to the underlying C GObject.
const GtkConstraintTarget * | gobj () const
| Provides access to the underlying C GObject.

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets.
static TextDirection | get_default_direction ()
| Obtains the current default reading direction.
Static Public Member Functions inherited from Gtk::Accessible
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
Static Public Member Functions inherited from Gtk::ConstraintTarget
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.

## Related Symbols
(Note that these are not member symbols.)
Gtk::ListBox * | wrap (GtkListBox * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Widget
Gtk::Widget * | wrap (GtkWidget * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Accessible
Glib::RefPtr< Gtk::Accessible > | wrap (GtkAccessible * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable * object, bool take_copy=false)
| A Glib::wrap() method for this object.
Related Symbols inherited from Gtk::ConstraintTarget
Glib::RefPtr< Gtk::ConstraintTarget > | wrap (GtkConstraintTarget * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Protected Member Functions inherited from Gtk::Widget
virtual void | root_vfunc ()
virtual void | unroot_vfunc ()
virtual void | size_allocate_vfunc (int width, int height, int baseline)
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | measure_vfunc (Orientation orientation, int for_size, int & minimum, int & natural, int & minimum_baseline, int & natural_baseline) const
virtual bool | grab_focus_vfunc ()
virtual void | set_focus_child_vfunc (Widget * child)
| Sets the focused child of widget.
virtual void | compute_expand_vfunc (bool & hexpand_p, bool & vexpand_p)
virtual bool | contains_vfunc (double x, double y) const
virtual void | snapshot_vfunc (const Glib::RefPtr< Gtk::Snapshot > & snapshot)
| Widget ()
void | realize ()
| Creates the GDK resources associated with a widget.
void | unrealize ()
| Causes a widget to be unrealized (frees all GDK resources associated with the widget).
void | realize_if_needed ()
void | set_focus_child (Widget & child)
| Set child as the current focus child of widget.
void | unset_focus_child ()
| Unsets the focus child of the widget.
Widget * | get_focus_child ()
| Returns the current focus child of widget.
const Widget * | get_focus_child () const
| Returns the current focus child of widget.
virtual void | on_show ()
| This is a default handler for the signal signal_show().
virtual void | on_hide ()
| This is a default handler for the signal signal_hide().
virtual void | on_map ()
| This is a default handler for the signal signal_map().
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap().
virtual void | on_realize ()
| This is a default handler for the signal signal_realize().
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize().
virtual void | on_state_flags_changed (Gtk::StateFlags previous_state_flags)
| This is a default handler for the signal signal_state_flags_changed().
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed().
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate().
virtual bool | on_query_tooltip (int x, int y, bool keyboard_tooltip, const Glib::RefPtr< Tooltip > & tooltip)
| This is a default handler for the signal signal_query_tooltip().
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Accessible
| Accessible ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it.
Protected Member Functions inherited from Gtk::ConstraintTarget
| ConstraintTarget ()
| You should derive from this class to use it.

## Detailed Description

A ListBox is a vertical container that contains ListBoxRow children.

These rows can by dynamically sorted and filtered, and headers can be added dynamically depending on the row content. It also allows keyboard and mouse navigation and selection like a typical list.

Using ListBox is often an alternative to TreeView, especially when the list contents have a more complicated layout than what is allowed by a CellRenderer, or when the contents are interactive (e.g. contain a button).

Although a ListBox must have only ListBoxRow children you can add any kind of widget to it via prepend(), append() and insert(), and a ListBoxRow widget will automatically be inserted between the list and the widget.

Also see FlowBox.

A ListBox looks like this:

Since gtkmm 3.10:

## Member Typedef Documentation

## ◆ SlotCreateWidget

template <typename T_item >

using Gtk::ListBox::SlotCreateWidget = sigc::slot<Gtk::Widget*(const Glib::RefPtr<T_item>&)>

For instance: Gtk::Widget* on_create_widget(const Glib::RefPtr<T_item>& item);.

Called for list boxes that are bound to a Gio::ListModel with bind_model() or bind_list_store() for each item that gets added to the model.

Versions of GTK+ prior to 3.18 called show_all() on the rows created by the SlotCreateWidget, but this forced all widgets inside the row to be shown, and is no longer the case. Applications should be updated to show the desired row widgets.

Since gtkmm 3.22:

Template Parameters

  T_item | Base class of the items in the Gio::ListModel. All items must be of type T_item or a type derived from T_item. T_item must be Glib::Object or a type derived from Glib::Object.

Parameters

  item | The item from the model for which to create a widget.

Returns
  A Gtk::Widget that represents item.

## ◆ SlotFilter

typedef sigc::slot<bool(ListBoxRow*)> Gtk::ListBox::SlotFilter

For instance: bool on_filter(ListBoxRow* row);.

Will be called whenever the row changes or is added and lets you control if the row should be visible or not.

Parameters

  row | The row that may be filtered

Returns
  `true` if the row should be visible, `false` otherwise

Since gtkmm 3.10:

## ◆ SlotForeach

typedef sigc::slot<void(ListBoxRow*)> Gtk::ListBox::SlotForeach

For instance, void on_foreach(ListBoxRow* row);.

## ◆ SlotSort

typedef sigc::slot<int(ListBoxRow*, ListBoxRow*)> Gtk::ListBox::SlotSort

For instance: int on_sort(ListBoxRow* row1, ListBoxRow* row2);.

Compare two rows to determine which should be first.

Parameters

  row1 | The first row
  row2 | The second row

Returns
  < 0 if row1 should be before row2, 0 if they are equal and > 0 otherwise

Since gtkmm 3.10:

## ◆ SlotUpdateHeader

typedef sigc::slot<void(ListBoxRow*, ListBoxRow*)> Gtk::ListBox::SlotUpdateHeader

For instance: void on_update_header(ListBoxRow* row, ListBoxRow* before);.

Whenever row changes or which row is before row changes this is called, which lets you update the header on row. You may remove or set a new one via ListBoxRow::set_header() or just change the state of the current header widget.

Parameters

  row | The row to update
  before | The row before row, or `0` if it is first

Since gtkmm 3.10:

## Constructor & Destructor Documentation

## ◆ ListBox() [1/3]

Gtk::ListBox::ListBox | ( | ListBox && | src | ) |
| noexcept

## ◆ ListBox() [2/3]

Gtk::ListBox::ListBox | ( | const ListBox & |  | ) |
| delete

## ◆ ~ListBox()

Gtk::ListBox::~ListBox | ( |  | ) |
| overridenoexcept

## ◆ ListBox() [3/3]

Gtk::ListBox::ListBox | ( |  | ) |

## Member Function Documentation

## ◆ append()

void Gtk::ListBox::append | ( | Widget & | child | ) |

Append a widget to the list.

If a sort function is set, the widget will actually be inserted at the calculated position.

Parameters

  child | The `Gtk::Widget` to add.

## ◆ bind_list_store()

template <typename T_item , typename T_slot >

void Gtk::ListBox::bind_list_store | ( | const Glib::RefPtr< Gio::ListStore< T_item > > & | store,
|  | T_slot && | slot_create_widget
| ) |  |

Binds a Gio::ListStore<>.

If this ListBox was already bound to a Gio::ListModel, that previous binding is destroyed. (Gio::ListStore is a Gio::ListModel.)

The contents of the ListBox are cleared and then filled with widgets that represent items from store. The ListBox is updated whenever store changes. If store is an empty Glib::RefPtr, the ListBox is left empty.

It is undefined to add or remove widgets directly (for example, with insert()) while the ListBox is bound to a model.

Note that using a model is incompatible with the filtering and sorting functionality in ListBox. When using a model, filtering and sorting should be implemented by the model.

Since gtkmm 3.22:

Template Parameters

  T_item | Base class of the items in the Gio::ListStore. All items must be of type T_item or a type derived from T_item. T_item must be Glib::Object or a type derived from Glib::Object.
  T_slot | SlotCreateWidget<T_item> or a type that can be converted to SlotCreateWidget<T_item>.

Parameters

  store | The Gio::ListStore<> to be bound.
  slot_create_widget | A slot that creates widgets for items.

## ◆ bind_model()

void Gtk::ListBox::bind_model | ( | const Glib::RefPtr< Gio::ListModel > & | model,
|  | const SlotCreateWidget< Glib::Object > & | slot_create_widget
| ) |  |

Binds a Gio::ListModel.

If this ListBox was already bound to a model, that previous binding is destroyed.

The contents of the ListBox are cleared and then filled with widgets that represent items from model. The ListBox is updated whenever model changes. If model is an empty Glib::RefPtr, the ListBox is left empty.

It is undefined to add or remove widgets directly (for example, with insert()) while the ListBox is bound to a model.

Note that using a model is incompatible with the filtering and sorting functionality in ListBox. When using a model, filtering and sorting should be implemented by the model.

Since gtkmm 3.22:

Parameters

  model | The Gio::ListModel to be bound.
  slot_create_widget | A slot that creates widgets for items.

See also
  bind_list_store()

## ◆ drag_highlight_row()

void Gtk::ListBox::drag_highlight_row | ( | ListBoxRow & | row | ) |

Add a drag highlight to a row.

This is a helper function for implementing DnD onto a `Gtk::ListBox`. The passed in row will be highlighted by setting the Gtk::StateFlags::DROP_ACTIVE state and any previously highlighted row will be unhighlighted.

The row will also be unhighlighted when the widget gets a drag leave event.

Parameters

  row | A `Gtk::ListBoxRow`.

## ◆ drag_unhighlight_row()

void Gtk::ListBox::drag_unhighlight_row | ( |  | ) |

If a row has previously been highlighted via drag_highlight_row(), it will have the highlight removed.

## ◆ get_activate_on_single_click()

bool Gtk::ListBox::get_activate_on_single_click | ( |  | ) | const

Returns whether rows activate on single clicks.

Returns
  `true` if rows are activated on single click, `false` otherwise.

## ◆ get_adjustment() [1/2]

Glib::RefPtr< Adjustment > Gtk::ListBox::get_adjustment | ( |  | ) |

Gets the adjustment (if any) that the widget uses to for vertical scrolling.

Returns
  The adjustment.

## ◆ get_adjustment() [2/2]

Glib::RefPtr< const Adjustment > Gtk::ListBox::get_adjustment | ( |  | ) | const

Gets the adjustment (if any) that the widget uses to for vertical scrolling.

Returns
  The adjustment.

## ◆ get_row_at_index() [1/2]

ListBoxRow * Gtk::ListBox::get_row_at_index | ( | int | index | ) |

Gets the n-th child in the list (not counting headers).

If index is negative or larger than the number of items in the list, `nullptr` is returned.

Parameters

  index | The index of the row.

Returns
  The child `Gtk::Widget`.

## ◆ get_row_at_index() [2/2]

const ListBoxRow * Gtk::ListBox::get_row_at_index | ( | int | index | ) | const

Gets the n-th child in the list (not counting headers).

If index is negative or larger than the number of items in the list, `nullptr` is returned.

Parameters

  index | The index of the row.

Returns
  The child `Gtk::Widget`.

## ◆ get_row_at_y() [1/2]

ListBoxRow * Gtk::ListBox::get_row_at_y | ( | int | y | ) |

Gets the row at the y position.

Parameters

  y | Position.

Returns
  The row.

## ◆ get_row_at_y() [2/2]

const ListBoxRow * Gtk::ListBox::get_row_at_y | ( | int | y | ) | const

Gets the row at the y position.

Parameters

  y | Position.

Returns
  The row.

## ◆ get_selected_row() [1/2]

ListBoxRow * Gtk::ListBox::get_selected_row | ( |  | ) |

Gets the selected row, or `nullptr` if no rows are selected.

Note that the box may allow multiple selection, in which case you should use selected_foreach() to find all selected rows.

Returns
  The selected row.

## ◆ get_selected_row() [2/2]

const ListBoxRow * Gtk::ListBox::get_selected_row | ( |  | ) | const

Gets the selected row, or `nullptr` if no rows are selected.

Note that the box may allow multiple selection, in which case you should use selected_foreach() to find all selected rows.

Returns
  The selected row.

## ◆ get_selected_rows() [1/2]

std::vector< ListBoxRow * > Gtk::ListBox::get_selected_rows | ( |  | ) |

Creates a list of all selected children.

Returns
  A `GList` containing the `Gtk::Widget` for each selected child.

## ◆ get_selected_rows() [2/2]

std::vector< ListBoxRow * > Gtk::ListBox::get_selected_rows | ( |  | ) | const

Creates a list of all selected children.

Returns
  A `GList` containing the `Gtk::Widget` for each selected child.

## ◆ get_selection_mode()

SelectionMode Gtk::ListBox::get_selection_mode | ( |  | ) | const

Gets the selection mode of the listbox.

Returns
  A `Gtk::SelectionMode`.

## ◆ get_show_separators()

bool Gtk::ListBox::get_show_separators | ( |  | ) | const

Returns whether the list box should show separators between rows.

Returns
  `true` if the list box shows separators.

## ◆ get_type()

static GType Gtk::ListBox::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkListBox * Gtk::ListBox::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkListBox * Gtk::ListBox::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ insert()

void Gtk::ListBox::insert | ( | Widget & | child,
|  | int | position
| ) |  |

Insert the child into the box at position.

If a sort function is set, the widget will actually be inserted at the calculated position.

If position is -1, or larger than the total number of items in the box, then the child will be appended to the end.

Parameters

  child | The `Gtk::Widget` to add.
  position | The position to insert child in.

## ◆ invalidate_filter()

void Gtk::ListBox::invalidate_filter | ( |  | ) |

Update the filtering for all rows.

Call this when result of the filter function on the box is changed due to an external factor. For instance, this would be used if the filter function just looked for a specific search string and the entry with the search string has changed.

## ◆ invalidate_headers()

void Gtk::ListBox::invalidate_headers | ( |  | ) |

Update the separators for all rows.

Call this when result of the header function on the box is changed due to an external factor.

## ◆ invalidate_sort()

void Gtk::ListBox::invalidate_sort | ( |  | ) |

Update the sorting for all rows.

Call this when result of the sort function on the box is changed due to an external factor.

## ◆ operator=() [1/2]

ListBox & Gtk::ListBox::operator= | ( | const ListBox & |  | ) |
| delete

## ◆ operator=() [2/2]

ListBox & Gtk::ListBox::operator= | ( | ListBox && | src | ) |
| noexcept

## ◆ prepend()

void Gtk::ListBox::prepend | ( | Widget & | child | ) |

Prepend a widget to the list.

If a sort function is set, the widget will actually be inserted at the calculated position.

Parameters

  child | The `Gtk::Widget` to add.

## ◆ property_accept_unpaired_release() [1/2]

Glib::PropertyProxy< bool > Gtk::ListBox::property_accept_unpaired_release | ( |  | ) |

Whether to accept unpaired release events.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_accept_unpaired_release() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ListBox::property_accept_unpaired_release | ( |  | ) | const

Whether to accept unpaired release events.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_activate_on_single_click() [1/2]

Glib::PropertyProxy< bool > Gtk::ListBox::property_activate_on_single_click | ( |  | ) |

Determines whether children can be activated with a single click, or require a double-click.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_activate_on_single_click() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ListBox::property_activate_on_single_click | ( |  | ) | const

Determines whether children can be activated with a single click, or require a double-click.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_selection_mode() [1/2]

Glib::PropertyProxy< SelectionMode > Gtk::ListBox::property_selection_mode | ( |  | ) |

The selection mode used by the list box.

Default value: Gtk::SelectionMode::SINGLE

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_selection_mode() [2/2]

Glib::PropertyProxy_ReadOnly< SelectionMode > Gtk::ListBox::property_selection_mode | ( |  | ) | const

The selection mode used by the list box.

Default value: Gtk::SelectionMode::SINGLE

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_separators() [1/2]

Glib::PropertyProxy< bool > Gtk::ListBox::property_show_separators | ( |  | ) |

Whether to show separators between rows.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_separators() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::ListBox::property_show_separators | ( |  | ) | const

Whether to show separators between rows.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove()

void Gtk::ListBox::remove | ( | Widget & | child | ) |

Removes a child from box.

Parameters

  child | The child to remove.

## ◆ remove_all()

void Gtk::ListBox::remove_all | ( |  | ) |

Removes all rows from box.

This function does nothing if box is backed by a model.

Since gtkmm 4.12:

## ◆ select_all()

void Gtk::ListBox::select_all | ( |  | ) |

Select all children of box, if the selection mode allows it.

## ◆ select_row()

void Gtk::ListBox::select_row | ( | ListBoxRow & | row | ) |

Make row the currently selected row.

Parameters

  row | The row to select.

## ◆ selected_foreach()

void Gtk::ListBox::selected_foreach | ( | const SlotForeach & | slot | ) |

## ◆ set_activate_on_single_click()

void Gtk::ListBox::set_activate_on_single_click | ( | bool | single = `true` | ) |

If single is `true`, rows will be activated when you click on them, otherwise you need to double-click.

Parameters

  single | A boolean.

## ◆ set_adjustment()

void Gtk::ListBox::set_adjustment | ( | const Glib::RefPtr< Adjustment > & | adjustment | ) |

Sets the adjustment (if any) that the widget uses to for vertical scrolling.

For instance, this is used to get the page size for PageUp/Down key handling.

In the normal case when the box is packed inside a `Gtk::ScrolledWindow` the adjustment from that will be picked up automatically, so there is no need to manually do that.

Parameters

  adjustment | The adjustment.

## ◆ set_filter_func()

void Gtk::ListBox::set_filter_func | ( | const SlotFilter & | slot | ) |

Sets a filter function.

By setting a filter function on the ListBox one can decide dynamically which of the rows to show. For instance, to implement a search function on a list that filters the original list to only show the matching rows.

The slot will be called for each row after the call, and it will continue to be called each time a row changes (via ListBoxRow::changed()) or when invalidate_filter() is called.

Parameters

  slot | Callback that lets you filter which rows to show

Since gtkmm 3.10:

## ◆ set_header_func()

void Gtk::ListBox::set_header_func | ( | const SlotUpdateHeader & | slot | ) |

Sets a header function.

By setting a header function on the ListBox one can dynamically add headers in front of rows, depending on the contents of the row and its position in the list. For instance, one could use it to add headers in front of the first item of a new kind, in a list sorted by the kind.

The slot can look at the current header widget using ListBoxRow::get_header() and either update the state of the widget as needed, or set a new one using ListBoxRow::set_header(). If no header is needed, use ListBoxRow::unset_header().

Note that you may get many calls to this slot for a particular row when e.g. changing things that don't affect the header. In this case it is important for performance to not blindly replace an exisiting header with an identical one.

The slot function will be called for each row after the call, and it will continue to be called each time a row changes (via ListBoxRow::changed()) and when the row before changes (either by ListBoxRow::changed() on the previous row, or when the previous row becomes a different row). It is also called for all rows when invalidate_headers() is called.

Parameters

  slot | Callback that lets you add row headers

Since gtkmm 3.10:

## ◆ set_placeholder()

void Gtk::ListBox::set_placeholder | ( | Widget & | placeholder | ) |

Sets the placeholder widget that is shown in the list when it doesn't display any visible children.

Parameters

  placeholder | A `Gtk::Widget`.

## ◆ set_selection_mode()

void Gtk::ListBox::set_selection_mode | ( | SelectionMode | mode | ) |

Sets how selection works in the listbox.

Parameters

  mode | The `Gtk::SelectionMode`.

## ◆ set_show_separators()

void Gtk::ListBox::set_show_separators | ( | bool | show_separators = `true` | ) |

Sets whether the list box should show separators between rows.

Parameters

  show_separators | `true` to show separators.

## ◆ set_sort_func()

void Gtk::ListBox::set_sort_func | ( | const SlotSort & | slot | ) |

Sets a sort function.

By setting a sort function on the ListBox one can dynamically reorder the rows of the list, based on the contents of the rows.

The slot will be called for each row after the call, and will continue to be called each time a row changes (via ListBoxRow::changed()) and when invalidate_sort() is called.

Parameters

  slot | The sort function.

Since gtkmm 3.10:

## ◆ signal_row_activated()

Glib::SignalProxy< void(ListBoxRow *)> Gtk::ListBox::signal_row_activated | ( |  | ) |

Slot Prototype:
  `void on_my_row_activated(ListBoxRow* row)`

Flags: Run Last

Emitted when a row has been activated by the user.

Parameters

  row | The activated row.

## ◆ signal_row_selected()

Glib::SignalProxy< void(ListBoxRow *)> Gtk::ListBox::signal_row_selected | ( |  | ) |

Slot Prototype:
  `void on_my_row_selected(ListBoxRow* row)`

Flags: Run Last

Emitted when a new row is selected, or (with a `nullptr` row) when the selection is cleared.

When the box is using Gtk::SelectionMode::MULTIPLE, this signal will not give you the full picture of selection changes, and you should use the signal_selected_rows_changed() signal instead.

Parameters

  row | The selected row.

## ◆ signal_selected_rows_changed()

Glib::SignalProxy< void()> Gtk::ListBox::signal_selected_rows_changed | ( |  | ) |

Slot Prototype:
  `void on_my_selected_rows_changed()`

Flags: Run First

Emitted when the set of selected rows changes.

## ◆ unselect_all()

void Gtk::ListBox::unselect_all | ( |  | ) |

Unselect all children of box, if the selection mode allows it.

## ◆ unselect_row() [1/2]

void Gtk::ListBox::unselect_row | ( |  | ) |

Unselects the currently selected row, if any.

Since gtkmm 3.10:

## ◆ unselect_row() [2/2]

void Gtk::ListBox::unselect_row | ( | ListBoxRow * | row | ) |

Unselects a single row of box, if the selection mode allows it.

Parameters

  row | The row to unselect.

## ◆ unset_filter_func()

void Gtk::ListBox::unset_filter_func | ( |  | ) |

Removes the filter function, if any.

Since gtkmm 3.10:

## ◆ unset_header_func()

void Gtk::ListBox::unset_header_func | ( |  | ) |

Removes the header function, if any.

Since gtkmm 3.10:

## ◆ unset_placeholder()

void Gtk::ListBox::unset_placeholder | ( |  | ) |

Removes the placeholder widget, if any.

Since gtkmm 3.10:

## ◆ unset_sort_func()

void Gtk::ListBox::unset_sort_func | ( |  | ) |

Removes the sort function, if any.

Since gtkmm 3.10:

## Friends And Related Symbol Documentation

## ◆ wrap()

Gtk::ListBox * wrap | ( | GtkListBox * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.